#include	<stdio.h>
#include	"gene.h"

FILE	*DataFile = NULL;
extern	char	*DataFileName;
extern	Individual	*Population;
extern	int	PopulationSize;
static	char	*bfp;

static int htoi()
{
	int	v;
	for (v = 0; *bfp; bfp++) {
		if ('0' <= *bfp && *bfp <= '9')
			v = (v << 4) + *bfp - '0';
		else if ('A' <= *bfp && *bfp <= 'F')
			v = (v << 4) + *bfp - 'A' + 10;
		else if ('a' <= *bfp && *bfp <= 'f')
			v = (v << 4) + *bfp - 'a' + 10;
		else { bfp++; return v; }
	}
}

b_load()
{
	int	i, j, k;
	char	buf[1300];
	fseek(DataFile, 0L, 0);
	for (i = 0; i < PopulationSize && fgets(buf,1300,DataFile); i++) {
		bfp = buf;
		for (j = 0; j < GeneLen; j ++) {
			k = htoi();
			Population[i].gene[j].state = (k >> 24) & 0xff;
			Population[i].gene[j].alpha = (k >> 16) & 0xff;
			Population[i].gene[j].beta = (k >> 8) & 0xff;
			Population[i].gene[j].gamma = k & 0xff;
		}
	}
}

b_save()
{
	int	i, j;
	fseek(DataFile, 0L, 0);
	for (i = 0; i < PopulationSize; i ++)
		for (j = 0; j < GeneLen; j ++)
			fprintf(DataFile,"%02x%02x%02x%02x%c",
				Population[i].gene[j].state,
				Population[i].gene[j].alpha,
				Population[i].gene[j].beta,
				Population[i].gene[j].gamma,
			((j<GeneLen-1)?':':'\n'));
	fflush(DataFile);
}

data_init(argc,argv) int argc; char *argv[];
{
	if (argc > 1) DataFileName = argv[1];
	if (!DataFileName) return 0;
	if (DataFile = fopen(DataFileName,"r+")) b_load();
	else if (DataFile = fopen(DataFileName,"w+"))
		fprintf(stderr,"%s: new file created.\n",DataFileName);
	else {
		perror(DataFileName);
		exit(1);
	}
}
