#include	<stdio.h>
#include	<string.h>
#include	"gene.h"

long	DrawWhen = 10;
char	*DataFileName = NULL;
int	MaxGeneration = 5;

extern	int	PopulationSize, GenerationLength, SeedForRandom, MaxCells;
extern	SelectionMode	SelMode;
extern	CrossoverMode	CrossMode;
extern	double	MutationRate;
typedef struct { char *com; int *var; } int_param;
typedef struct { char *name; SelectionMode value; } sel_value;
typedef	struct { char *name; CrossoverMode value; } cross_value;

static	int_param	iparam[] = {
	{"PopulationSize",&PopulationSize},
	{"GenerationLength",&GenerationLength},
	{"SeedForRandom",&SeedForRandom},
	{"MaxCells",&MaxCells},
	{"MaxGeneration",&MaxGeneration},{NULL}
};
static	sel_value	s_value[] = {
	{"Global3rd",SelGlobal3rd},{"Local3rd",SelLocal3rd},
	{"LocalSel",SelLocalSel},{NULL}
};
static	cross_value	c_value[] = {
	{"OnePoint",CrsOnePoint},{"TwoPoints",CrsTwoPoints},
	{"Uniform",CrsUniform},{NULL}
};

gr_init(argc,argv)
int	argc;
char	*argv[];
{
	int_param	*p;
	sel_value	*ps;
	cross_value	*pc;
	char	*c;
	int	flag;
	char	buf[BUFSIZ];
	while (fgets(buf,BUFSIZ,stdin),!feof(stdin)) {
		flag = 0;
		if (!(c = strtok(buf,"\t ,"))) continue;
		for (p = iparam; p->com; p ++) if (!strcmp(p->com,c)) {
			if (c = strtok(NULL,"\t\n ,")) *(p->var) = atoi(c);
			flag = 1; break;
		}
		if (!flag) {
			if (!strcmp("SelectionMode",c)) {
				if (c = strtok(NULL,"\t\n ,"))
				for (ps = s_value; ps->name; ps ++)
				if (!strcmp(ps->name,c))
					{ SelMode = ps->value; break; }
			} else if (!strcmp("CrossoverMode",c)) {
				if (c = strtok(NULL,"\t\n ,"))
				for (pc = c_value; pc->name; pc ++)
				if (!strcmp(pc->name,c))
					{ CrossMode = pc->value; break; }
			}
		}
	}
	srand48(SeedForRandom?SeedForRandom:time(0));
}
extern	unsigned long	Generation;
event_loop() {
	while (Generation <= MaxGeneration)
		if (!exec_one_step()) selection();
}
redraw_world() {}
draw_info() {}
viewg() {}
viewe_display(best,average) int best, average;
{ printf("%d %d\n",Generation,best); }
viewe_reset() {}
move_view_point() {}
