#! /bin/csh
#
switch (`uname`)
case SunOS:
cat >! Makefile.tmp << EOF
CFLAGS=-O -DSolaris -I/usr/dt/include
LFLAGS=-L/usr/dt/lib
XLIBS=-lXm -lXt -lXpm -lICE -lSM -lX11
LIBS=-lm
EOF
breaksw
case HP-UX:
case HI-UX:
cat >! Makefile.tmp << EOF
CFLAGS=+O2 -DHPUX -I/usr/include/X11R5 -I/usr/include/Motif1.2
LFLAGS=-L/usr/lib/X11R5 -L/usr/lib/Motif1.2 -L/usr/local/lib
XLIBS=-lXm -lXt -lXpm -lX11
LIBS=-lM
EOF
breaksw
case IRIX:
cat >! Makefile.tmp << EOF
CFLAGS=-O -DSGI
XLIBS=-lXm -lXt -lXpm -lX11
LIBS=-lm
EOF
breaksw
case JCC_BSD+:
cat >! Makefile.tmp << EOF
CFLAGS=-O -DBSD4
XLIBS=-lXm -lXt -lXpm -lX11
LIBS=-lm
EOF
breaksw
case Linux:
cat >! Makefile.tmp << EOF
CFLAGS=-O -DLINUX
LFLAGS=-L/usr/X11R6/lib
XLIBS=-lXm -lXpm -lXext -lXt -lXpm -lSM -lICE -lX11
LIBS=-lm
EOF
breaksw
case FreeBSD:
cat >! Makefile.tmp << EOF
CFLAGS=-O -DFreeBSD -I/usr/X11R6/include
LFLAGS=-L/usr/X11R6/lib
XLIBS=-lXm -lXpm -lXext -lXt -lXpm -lSM -lICE -lX11
LIBS=-lm
EOF
breaksw
default:
echo "Sorry. I don't know how to compile on " `uname`.
exit 1
endsw
cat Makefile.tmp Makefile.dst >! Makefile
rm -f Makefile.tmp
make -f Makefile
exit 0
